(function(global) {
      if (global.FXJSBridge) return;

      var invokeCallbacks = {};
      var invokeCallbackId = 0;

      var _invokeHandler = function(event, paramsString, callbackId) {
          global.nplusapp.invokeHandler(
             event,
             paramsString,
             callbackId
          )
      }

      var invoke = function(event, params, callback) {
        var paramsString = JSON.stringify(params || {});
        if (typeof callback === 'function') {
          var callbackId = ++invokeCallbackId
          invokeCallbacks[callbackId] = callback;
          _invokeHandler(event, paramsString, callbackId);
        }else {
          _invokeHandler(event, paramsString,-1);
        }
      }

      var invokeCallbackHandler = function(callbackId, result) {
        var callback = invokeCallbacks[callbackId];
        if (typeof callback == 'function') {
          callback(result);
        }
        delete invokeCallbacks[callbackId];
      }

      global.FXJSBridge = {
        invoke: invoke,
        invokeCallbackHandler: invokeCallbackHandler,
      }

    }) (this);